/*
	Data structures

	Author:   Steffen Rendle, http://www.libfm.org/
	modified: 2011-07-14

	Copyright 2010-2011 Steffen Rendle, see license.txt for more information
*/

#ifndef DATA_H_
#define DATA_H_

#include <limits>
#include "../../util/matrix.h"


class Data {
	public:
		Data() {  }
		DMatrix<int> data;
		int min_target;
		int max_target;
		
		void load(std::string filename);	
		void debug();	
		int& target(int i) {
			return data(i,data.dim2-1);
		}
};

void Data::load(std::string filename) {
	data._load(filename, false);
	min_target = +std::numeric_limits<int>::max();
	max_target = -std::numeric_limits<int>::max();
	for (uint i = 0; i < data.dim1; i++) {
		min_target = std::min(min_target, target(i));
		max_target = std::max(max_target, target(i));
	}	
}

void Data::debug() {
	for (uint i = 0; i < std::min(data.dim1, (uint) 4); i++) {
		for (uint j = 0; j < data.dim2; j++) {
			std::cout << data(i,j) << "\t";
		}
		std::cout << std::endl;	
	}	
}


#endif /*DATA_H_*/
